org.eclipse.incquery.runtime.evm.specific

## Class Rules

- java.lang.Object
- - org.eclipse.incquery.runtime.evm.specific.Rules

-     public final class Rules
      extends java.lang.Object

  Provides static methods acting on or generating a `RuleSpecification`.
  Author:
    Abel Hegedus

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Rules()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <Match extends IPatternMatch> RuleSpecification<Match>` | `newMatcherRuleSpecification(IncQueryMatcher<Match> matcher, ActivationLifeCycle lifecycle, java.util.Set<Job<Match>> jobs)`
    `static <Match extends IPatternMatch> RuleSpecification<Match>` | `newMatcherRuleSpecification(IQuerySpecification<? extends IncQueryMatcher<Match>> querySpecification, ActivationLifeCycle lifecycle, java.util.Set<Job<Match>> jobs)` Creates a `RuleSpecification` with the given query specification, life-cycle and jobs.
    `static <Match extends IPatternMatch> RuleSpecification<Match>` | `newMatcherRuleSpecification(IQuerySpecification<? extends IncQueryMatcher<Match>> querySpecification, java.util.Set<Job<Match>> jobs)` Creates a `RuleSpecification` with the given query specification and jobs, using the `DefaultActivationLifeCycle.DEFAULT` life-cycle.
    `static <Match extends IPatternMatch> EventFilter<Match>` | `newMultiMatchFilter(java.util.Collection<Match> filterMatches, IncQueryFilterSemantics semantics)` Creates a "multi" event filter that uses the IPatternMatch.isCompatibleWith to check event atoms against a collection of filter (partial) matches.
    `static <Match extends IPatternMatch> EventFilter<Match>` | `newSingleMatchFilter(Match filterMatch)` Creates an event filter that uses the IPatternMatch.isCompatibleWith to check event atoms.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Rules

          public Rules()

  - ### Method Detail

    - #### newMatcherRuleSpecification

          public static <Match extends IPatternMatch> RuleSpecification<Match> newMatcherRuleSpecification(IQuerySpecification<? extends IncQueryMatcher<Match>> querySpecification,
                                                                                                           ActivationLifeCycle lifecycle,
                                                                                                           java.util.Set<Job<Match>> jobs)

      Creates a `RuleSpecification` with the given query specification, life-cycle and jobs. For default life-cycle implementations, see `DefaultActivationLifeCycle`.
      Parameters:
        `querySpecification` -
        `lifecycle` -
        `jobs` -

    - #### newMatcherRuleSpecification

          public static <Match extends IPatternMatch> RuleSpecification<Match> newMatcherRuleSpecification(IQuerySpecification<? extends IncQueryMatcher<Match>> querySpecification,
                                                                                                           java.util.Set<Job<Match>> jobs)

      Creates a `RuleSpecification` with the given query specification and jobs, using the `DefaultActivationLifeCycle.DEFAULT` life-cycle.
      Parameters:
        `querySpecification` -
        `jobs` -

    - #### newMatcherRuleSpecification

          public static <Match extends IPatternMatch> RuleSpecification<Match> newMatcherRuleSpecification(IncQueryMatcher<Match> matcher,
                                                                                                           ActivationLifeCycle lifecycle,
                                                                                                           java.util.Set<Job<Match>> jobs)

    - #### newSingleMatchFilter

          public static <Match extends IPatternMatch> EventFilter<Match> newSingleMatchFilter(Match filterMatch)

      Creates an event filter that uses the IPatternMatch.isCompatibleWith to check event atoms.

      Using the matches that are equal will result in equal filters.
      Parameters:
        `filterMatch` - non-null match to use for filtering
      Returns:
        the event filter

    - #### newMultiMatchFilter

          public static <Match extends IPatternMatch> EventFilter<Match> newMultiMatchFilter(java.util.Collection<Match> filterMatches,
                                                                                             IncQueryFilterSemantics semantics)

      Creates a "multi" event filter that uses the IPatternMatch.isCompatibleWith to check event atoms against a collection of filter (partial) matches. The possible semantics are documented in `IncQueryFilterSemantics`.
      Parameters:
        `filterMatches` - non-null match to use for filtering
        `semantics` - the filter semantics to use
      Returns:
        the event filter